## civetweb 1.13+dfsg

=== CMakeLists.txt ===
# Determines what CMake APIs we can rely on
cmake_minimum_required (VERSION 2.8.11)
if (${CMAKE_VERSION} VERSION_GREATER 3.2.2)
  cmake_policy(VERSION 3.2.2)
endif()
if (${CMAKE_VERSION} VERSION_GREATER 3.1 OR
    ${CMAKE_VERSION} VERSION_EQUAL 3.1)
  cmake_policy(SET CMP0054 NEW)
endif()

# Set up the project
project (civetweb)

# Detect the platform reliably
if(ZEPHYR_BASE)
    if (NOT CONFIG_CIVETWEB)
      return()
    endif()
    SET(ZEPHYR YES)
elseif(NOT MACOSX AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET(DARWIN YES)
elseif(NOT BSD AND ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    SET(FREEBSD YES)
elseif(NOT LINUX AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    SET(LINUX YES)
endif()

# Do not allow in source builds
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

# Make sure we can import out CMake functions
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Load in the needed CMake modules
include(CheckIncludeFiles)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(AddCCompilerFlag)
include(AddCXXCompilerFlag)
include(DetermineTargetArchitecture)
include(CMakeDependentOption)

set(CIVETWEB_VERSION "1.13.0" CACHE STRING "The version of the civetweb library")
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" CIVETWEB_VERSION_MATCH "${CIVETWEB_VERSION}")
if ("${CIVETWEB_VERSION_MATCH}" STREQUAL "")
  message(FATAL_ERROR "Must specify a semantic version: major.minor.patch")
endif()
set(CIVETWEB_VERSION_MAJOR "${CMAKE_MATCH_1}")
set(CIVETWEB_VERSION_MINOR "${CMAKE_MATCH_2}")
set(CIVETWEB_VERSION_PATCH "${CMAKE_MATCH_3}")
determine_target_architecture(CIVETWEB_ARCHITECTURE)
include(GNUInstallDirs)

# CTest automation
option(CIVETWEB_BUILD_TESTING "Enable automated testing of civetweb" ON)
message(STATUS "Enabling tests in the build - ${CIVETWEB_BUILD_TESTING}")

# C++ wrappers
option(CIVETWEB_ENABLE_THIRD_PARTY_OUTPUT "Shows the output of third party dependency processing" OFF)

# Thread Stack Size
set(CIVETWEB_THREAD_STACK_SIZE 102400 CACHE STRING
  "The stack size in bytes for each thread created")
set_property(CACHE CIVETWEB_THREAD_STACK_SIZE PROPERTY VALUE ${CIVETWEB_THREAD_STACK_SIZE})
message(STATUS "Thread Stack Size - ${CIVETWEB_THREAD_STACK_SIZE}")

option(CIVETWEB_ENABLE_SERVER_EXECUTABLE "Enable building of the server executable" ON)
message(STATUS "Enabling server executable - ${CIVETWEB_ENABLE_SERVER_EXECUTABLE}")

# Serve no files from the web server
option(CIVETWEB_SERVE_NO_FILES "Configures the server to serve no static files" OFF)
message(STATUS "Serve no static files - ${CIVETWEB_SERVE_NO_FILES}")

# Serve no files from the web server
option(CIVETWEB_DISABLE_CGI "Disables CGI, so theserver will not execute CGI scripts" OFF)
message(STATUS "Disable CGI support - ${CIVETWEB_DISABLE_CGI}")

# Disable caching
option(CIVETWEB_DISABLE_CACHING "Disables caching, so that no timegm is used." OFF)
message(STATUS "Disable caching support - ${CIVETWEB_DISABLE_CACHING}")

# C++ wrappers
option(CIVETWEB_ENABLE_CXX "Enables the C++ wrapper library" OFF)
message(STATUS "C++ wrappers - ${CIVETWEB_ENABLE_CXX}")

# IP Version 6
option(CIVETWEB_ENABLE_IPV6 "Enables the IP version 6 support" OFF)
message(STATUS "IP Version 6 - ${CIVETWEB_ENABLE_IPV6}")

# Websocket support
option(CIVETWEB_ENABLE_WEBSOCKETS "Enable websockets connections" OFF)
message(STATUS "Websockets support - ${CIVETWEB_ENABLE_WEBSOCKETS}")

# Server statistics support
option(CIVETWEB_ENABLE_SERVER_STATS "Enable server statistics" OFF)
message(STATUS "Server statistics support - ${CIVETWEB_ENABLE_SERVER_STATS}")

# Memory debugging
option(CIVETWEB_ENABLE_MEMORY_DEBUGGING "Enable the memory debugging features" OFF)
message(STATUS "Memory Debugging - ${CIVETWEB_ENABLE_MEMORY_DEBUGGING}")

# ASAN in debug mode (-fsanitize=address, etc)
option(CIVETWEB_ENABLE_ASAN "Enable ASAN in debug mode" ON)
message(STATUS "ASAN in debug mode - ${CIVETWEB_ENABLE_ASAN}")

# ARCH flag
option(CIVETWEB_ARCH "Force 32/64 bit architecture" OFF)
message(STATUS "Force x32 / x64 architecture - ${CIVETWEB_ARCH}")

# LUA CGI support
option(CIVETWEB_ENABLE_LUA "Enable Lua CGIs" OFF)
message(STATUS "Lua CGI support - ${CIVETWEB_ENABLE_LUA}")

# Enable installing CivetWeb executables
option(CIVETWEB_INSTALL_EXECUTABLE "Enable installing CivetWeb executable" ON)
mark_as_advanced(FORCE CIVETWEB_INSTALL_EXECUTABLE) # Advanced users can disable
message(STATUS "Executable installation - ${CIVETWEB_INSTALL_EXECUTABLE}")

# Allow builds to complete with warnings (do not set -Werror)
# CivetWeb Linux support is stable:
# Builds for GCC 4.6 and clang 3.4 are free from warnings.
# However, GCC introduced a couple of new, partially idiotic warnings,
# that can not be disabled using a #pragma directive.
# It seems unreasonable to have all GCC versions warning free, but only
# some selected ones.
option(CIVETWEB_ALLOW_WARNINGS "Do not stop build if there are warnings" ON)
message(STATUS "Build if there are warnings - ${CIVETWEB_ALLOW_WARNINGS}")

if (NOT CIVETWEB_ALLOW_WARNINGS)
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    message(FATAL_ERROR "Cannot compile with warning as errors, until this GCC bug is solved: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=53431")
  endif()
endif()

# Link to the shared LUA library
cmake_dependent_option(
  CIVETWEB_ENABLE_LUA_SHARED  "Link to the shared LUA system library" OFF
 CIVETWEB_ENABLE_LUA OFF)
if (CIVETWEB_ENABLE_LUA)
  message(STATUS "Linking shared Lua library - ${CIVETWEB_ENABLE_LUA_SHARED}")
endif()

# Lua Third Party Settings
if (CIVETWEB_ENABLE_LUA)
  if (NOT CIVETWEB_ENABLE_LUA_SHARED)
    # Lua Version
    set(CIVETWEB_LUA_VERSION 5.2.4 CACHE STRING
      "The version of Lua to build and include statically")
    set_property(CACHE CIVETWEB_LUA_VERSION PROPERTY VALUE ${CIVETWEB_LUA_VERSION})
    message(STATUS "Lua Version - ${CIVETWEB_LUA_VERSION}")
    mark_as_advanced(CIVETWEB_LUA_VERSION)

    # Lua Verification Hash
    set(CIVETWEB_LUA_MD5_HASH 913fdb32207046b273fdb17aad70be13 CACHE STRING
      "The hash of Lua archive to be downloaded")
    set_property(CACHE CIVETWEB_LUA_MD5_HASH PROPERTY VALUE ${CIVETWEB_LUA_MD5_HASH})
    mark_as_advanced(CIVETWEB_LUA_MD5_HASH)
  endif()

  # Lua Filesystem Version
  set(CIVETWEB_LUA_FILESYSTEM_VERSION 1.6.3 CACHE STRING
    "The version of Lua Filesystem to build and include statically")
  set_property(CACHE CIVETWEB_LUA_FILESYSTEM_VERSION PROPERTY VALUE ${CIVETWEB_LUA_FILESYSTEM_VERSION})
  message(STATUS "Lua Filesystem Version - ${CIVETWEB_LUA_FILESYSTEM_VERSION}")
  mark_as_advanced(CIVETWEB_LUA_FILESYSTEM_VERSION)

  # Lua Filesystem Verification Hash
  set(CIVETWEB_LUA_FILESYSTEM_MD5_HASH d0552c7e5a082f5bb2865af63fb9dc95 CACHE STRING
    "The hash of Lua Filesystem archive to be downloaded")
  set_property(CACHE CIVETWEB_LUA_FILESYSTEM_MD5_HASH PROPERTY VALUE ${CIVETWEB_LUA_FILESYSTEM_MD5_HASH})
  mark_as_advanced(CIVETWEB_LUA_FILESYSTEM_MD5_HASH)

  # Lua SQLite Version
  set(CIVETWEB_LUA_SQLITE_VERSION 0.9.3 CACHE STRING
    "The version of Lua SQLite to build and include statically")
  set_property(CACHE CIVETWEB_LUA_SQLITE_VERSION PROPERTY VALUE ${CIVETWEB_LUA_SQLITE_VERSION})
  message(STATUS "Lua SQLite Version - ${CIVETWEB_LUA_SQLITE_VERSION}")
  mark_as_advanced(CIVETWEB_LUA_SQLITE_VERSION)

  # Lua SQLite Verification Hash
  set(CIVETWEB_LUA_SQLITE_MD5_HASH 43234ae08197dfce6da02482ed14ec92 CACHE STRING
    "The hash of Lua SQLite archive to be downloaded")
  set_property(CACHE CIVETWEB_LUA_SQLITE_MD5_HASH PROPERTY VALUE ${CIVETWEB_LUA_SQLITE_MD5_HASH})
  mark_as_advanced(CIVETWEB_LUA_SQLITE_MD5_HASH)

  # Lua XML Version
  set(CIVETWEB_LUA_XML_VERSION 1.8.0 CACHE STRING
    "The version of Lua XML to build and include statically")
  set_property(CACHE CIVETWEB_LUA_XML_VERSION PROPERTY VALUE ${CIVETWEB_LUA_XML_VERSION})
  message(STATUS "Lua XML Version - ${CIVETWEB_LUA_XML_VERSION}")
  mark_as_advanced(CIVETWEB_LUA_XML_VERSION)

  # Lua XML Verification Hash
  set(CIVETWEB_LUA_XML_MD5_HASH 25e4c276c5d8716af1de0c7853aec2b4 CACHE STRING
    "The hash of Lua XML archive to be downloaded")
  set_property(CACHE CIVETWEB_LUA_XML_MD5_HASH PROPERTY VALUE ${CIVETWEB_LUA_XML_MD5_HASH})
  mark_as_advanced(CIVETWEB_LUA_XML_MD5_HASH)

  # SQLite Version
  set(CIVETWEB_SQLITE_VERSION 3.8.9 CACHE STRING
    "The version of SQLite to build and include statically")
  set_property(CACHE CIVETWEB_SQLITE_VERSION PROPERTY VALUE ${CIVETWEB_SQLITE_VERSION})
  message(STATUS "SQLite Version - ${CIVETWEB_SQLITE_VERSION}")
  mark_as_advanced(CIVETWEB_SQLITE_VERSION)

  # SQLite Verification Hash
  set(CIVETWEB_SQLITE_MD5_HASH 02e9c3a6daa8b8587cf6bef828c2e33f CACHE STRING
    "The hash of SQLite archive to be downloaded")
  set_property(CACHE CIVETWEB_SQLITE_MD5_HASH PROPERTY VALUE ${CIVETWEB_SQLITE_MD5_HASH})
  mark_as_advanced(CIVETWEB_SQLITE_MD5_HASH)
endif()

# Duktape CGI support
option(CIVETWEB_ENABLE_DUKTAPE "Enable Duktape CGIs" OFF)
message(STATUS "Duktape CGI support - ${CIVETWEB_ENABLE_DUKTAPE}")

# SSL support
option(CIVETWEB_ENABLE_SSL "Enables the secure socket layer" ON)
message(STATUS "SSL support - ${CIVETWEB_ENABLE_SSL}")

# OpenSSL 1.0 API
option(CIVETWEB_SSL_OPENSSL_API_1_0 "Use the OpenSSL 1.0 API" OFF)
message(STATUS "Compile for OpenSSL 1.0 API - ${CIVETWEB_SSL_OPENSSL_API_1_0}")

# OpenSSL 1.1 API
option(CIVETWEB_SSL_OPENSSL_API_1_1 "Use the OpenSSL 1.1 API" ON)
message(STATUS "Compile for OpenSSL 1.1 API - ${CIVETWEB_SSL_OPENSSL_API_1_1}")

# Dynamically load or link the SSL libraries
cmake_dependent_option(
  CIVETWEB_ENABLE_SSL_DYNAMIC_LOADING "Dynamically loads the SSL library rather than linking it" ON
  CIVETWEB_ENABLE_SSL OFF)
if (CIVETWEB_ENABLE_SSL)
  message(STATUS "Dynamically load SSL libraries - ${CIVETWEB_ENABLE_SSL_DYNAMIC_LOADING}")
endif()

# Link time optimization
option(CIVETWEB_ENABLE_LTO "Enable link time optimization" OFF)
if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
    "${BUILD_SHARED_LIBS}" STREQUAL "SHARED" OR
    ${CMAKE_CXX_COMPILER_VERSION} GREATER 5)
  option(CIVETWEB_CXX_ENABLE_LTO "Enable link time optimization for the C++ wrapper library" ON)
else()
  option(CIVETWEB_CXX_ENABLE_LTO "Enable link time optimization for the C++ wrapper library" OFF)
endif()

# Third Party Download location
set(CIVETWEB_THIRD_PARTY_DIR "${CMAKE_BINARY_DIR}/third_party" CACHE STRING
  "The location that third party code is downloaded, built and installed")
set_property(CACHE CIVETWEB_THIRD_PARTY_DIR PROPERTY VALUE ${CIVETWEB_THIRD_PARTY_DIR})

# Unix systems can define the dynamic library names to load
if (CIVETWEB_ENABLE_SSL_DYNAMIC_LOADING AND NOT DARWIN AND UNIX)
  # SSL library name
  set(CIVETWEB_SSL_SSL_LIB "libssl.so" CACHE STRING
    "The name of the SSL library to load")
  set_property(CACHE CIVETWEB_SSL_SSL_LIB PROPERTY VALUE ${CIVETWEB_SSL_SSL_LIB})
  message(STATUS "SSL Library Name - ${CIVETWEB_SSL_SSL_LIB}")

  # Crytography library name
  set(CIVETWEB_SSL_CRYPTO_LIB "libcrypto.so" CACHE STRING
    "The name of the SSL Cryptography library to load")
  set_property(CACHE CIVETWEB_SSL_CRYPTO_LIB PROPERTY VALUE ${CIVETWEB_SSL_CRYPTO_LIB})
  message(STATUS "SSL Cryptography Library Name - ${CIVETWEB_SSL_CRYPTO_LIB}")
endif()

# Allow warnings in 3rd party components
if (CIVETWEB_ENABLE_LUA OR CIVETWEB_ENABLE_DUKTAPE)
SET(CIVETWEB_ALLOW_WARNINGS YES)
endif()

# The C and C++ standards to use
set(CIVETWEB_C_STANDARD auto CACHE STRING
  "The C standard to use; auto determines the latest supported by the compiler")
set_property(CACHE CIVETWEB_C_STANDARD PROPERTY STRINGS auto c11 c99 c89)
set(CIVETWEB_CXX_STANDARD auto CACHE STRING
  "The C++ standard to use; auto determines the latest supported by the compiler")
set_property(CACHE CIVETWEB_CXX_STANDARD PROPERTY STRINGS auto c++14 c++11 c++98)

# Configure the linker
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
  find_program(GCC_AR gcc-ar)
  if (GCC_AR)
    set(CMAKE_AR ${GCC_AR})
  endif()

=== unittest/CMakeLists.txt ===
# Determine if we should print to the output
if (CIVETWEB_ENABLE_THIRD_PARTY_OUTPUT)
  set(THIRD_PARTY_LOGGING 0)
else()
  set(THIRD_PARTY_LOGGING 1)
endif()

# We use the check unit testing framework for our C unit tests
include(ExternalProject)
if(NOT WIN32)
  # Apply the patch to check to fix CMake building on OS X
  set(CHECK_PATCH_COMMAND patch
     ${CIVETWEB_THIRD_PARTY_DIR}/src/check-unit-test-framework/src/check_run.c
     ${CMAKE_SOURCE_DIR}/cmake/check/check_run.patch
   )
else()
  set(CHECK_PATCH_COMMAND "")
endif()

IF (DEFINED ENV{CHECK_URL})
SET (CHECK_URL $ENV{CHECK_URL})
ELSE()
SET (CHECK_URL "https://github.com/civetweb/check/archive/master.zip")
ENDIF()


ExternalProject_Add(check-unit-test-framework
  DEPENDS civetweb-c-library

## Use an official, released check version:
#  URL "https://codeload.github.com/libcheck/check/zip/${CIVETWEB_CHECK_VERSION}"
#  DOWNLOAD_NAME "${CIVETWEB_CHECK_VERSION}.zip"
#  URL_MD5 ${CIVETWEB_CHECK_MD5_HASH}

## Use a civetweb specific patched version

URL ${CHECK_URL}
DOWNLOAD_NAME "master.zip"

  PREFIX "${CIVETWEB_THIRD_PARTY_DIR}"
  BUILD_IN_SOURCE 1
  PATCH_COMMAND ${CHECK_PATCH_COMMAND}
  CMAKE_ARGS
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
    "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}"
    "-DCMAKE_INSTALL_PREFIX=<INSTALL_DIR>"
  LOG_DOWNLOAD ${THIRD_PARTY_LOGGING}
  LOG_UPDATE ${THIRD_PARTY_LOGGING}
  LOG_CONFIGURE ${THIRD_PARTY_LOGGING}
  LOG_BUILD ${THIRD_PARTY_LOGGING}
  LOG_TEST ${THIRD_PARTY_LOGGING}
  LOG_INSTALL ${THIRD_PARTY_LOGGING})

ExternalProject_Get_Property(check-unit-test-framework INSTALL_DIR)
set(CHECK_INSTALL_DIR ${INSTALL_DIR})
unset(INSTALL_DIR)
link_directories("${CHECK_INSTALL_DIR}/lib")
include_directories("${CHECK_INSTALL_DIR}/include")
if ((WIN32 AND MINGW) OR APPLE)
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};${CHECK_INSTALL_DIR}/lib/libcheck.a")
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};${CHECK_INSTALL_DIR}/lib/libcompat.a")
elseif (WIN32)
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};${CHECK_INSTALL_DIR}/lib/check.lib")
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};${CHECK_INSTALL_DIR}/lib/compat.lib")
else()
  set(CHECK_LIBRARIES "${CHECK_INSTALL_DIR}/lib/libcheck.a")
endif()
find_package(LibM)
if (LIBM_FOUND)
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};LIBM::LIBM")
endif()
find_package(LibRt)
if (LIBRT_FOUND)
  set(CHECK_LIBRARIES "${CHECK_LIBRARIES};LIBRT::LIBRT")
endif()

# Build the C unit tests
add_library(shared-c-unit-tests STATIC shared.c)
target_include_directories(
  shared-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)

add_library(public-func-c-unit-tests STATIC public_func.c)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(public-func-c-unit-tests PRIVATE CIVETWEB_DLL_IMPORTS)
endif()
target_include_directories(
  public-func-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)
target_link_libraries(public-func-c-unit-tests civetweb-c-library ${CHECK_LIBRARIES})
add_dependencies(public-func-c-unit-tests check-unit-test-framework)

add_library(public-server-c-unit-tests STATIC public_server.c)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(public-server-c-unit-tests PRIVATE CIVETWEB_DLL_IMPORTS)
endif()
target_include_directories(
  public-server-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)
target_link_libraries(public-server-c-unit-tests civetweb-c-library ${CHECK_LIBRARIES})
add_dependencies(public-server-c-unit-tests check-unit-test-framework)

add_library(private-c-unit-tests STATIC private.c)
target_include_directories(
  private-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)
target_link_libraries(private-c-unit-tests ${CHECK_LIBRARIES})
add_dependencies(private-c-unit-tests check-unit-test-framework)

add_library(timer-c-unit-tests STATIC timertest.c)
target_include_directories(
  timer-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)
target_link_libraries(timer-c-unit-tests ${CHECK_LIBRARIES})
add_dependencies(timer-c-unit-tests check-unit-test-framework)

add_library(exe-c-unit-tests STATIC private_exe.c)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(exe-c-unit-tests PRIVATE)
endif()
target_include_directories(
  exe-c-unit-tests PUBLIC
  ${PROJECT_SOURCE_DIR}/include)
target_link_libraries(exe-c-unit-tests civetweb-c-library ${CHECK_LIBRARIES})
add_dependencies(exe-c-unit-tests check-unit-test-framework)

add_executable(main-c-unit-test main.c)
target_link_libraries(main-c-unit-test
  shared-c-unit-tests
  public-func-c-unit-tests
  public-server-c-unit-tests
  private-c-unit-tests
  timer-c-unit-tests
  exe-c-unit-tests
  ${CHECK_LIBRARIES})
add_dependencies(main-c-unit-test check-unit-test-framework)

# Add a check command that builds the dependent test program
add_custom_target(check
  COMMAND ${CMAKE_CTEST_COMMAND}
  DEPENDS main-c-unit-test)

# A macro for adding tests
macro(civetweb_add_test suite test_case)
  set(test "test-${suite}-${test_case}")
  string(TOLOWER "${test}" test)
  string(REGEX REPLACE "[^-A-Za-z0-9]" "-" test "${test}")
  add_test(
    NAME ${test}
    COMMAND main-c-unit-test "--test-dir=${CMAKE_CURRENT_SOURCE_DIR}" "--suite=${suite}" "--test-case=${test_case}")
  if (WIN32)
    string(REPLACE ";" "\\;" test_path "$ENV{PATH}")
    set_tests_properties(${test} PROPERTIES
      ENVIRONMENT "PATH=${test_path}\\;$<TARGET_FILE_DIR:civetweb-c-library>")
  endif()
endmacro(civetweb_add_test)


# Tests of private functions
civetweb_add_test(Private "HTTP Message")
civetweb_add_test(Private "HTTP Keep Alive")
civetweb_add_test(Private "URL Parsing 1")
civetweb_add_test(Private "URL Parsing 2")
civetweb_add_test(Private "URL Parsing 3")
civetweb_add_test(Private "Internal Parsing 1")
civetweb_add_test(Private "Internal Parsing 2")
civetweb_add_test(Private "Internal Parsing 3")
civetweb_add_test(Private "Internal Parsing 4")
civetweb_add_test(Private "Internal Parsing 5")
civetweb_add_test(Private "Internal Parsing 6")
civetweb_add_test(Private "Encode Decode")
civetweb_add_test(Private "Mask Data")
civetweb_add_test(Private "Date Parsing")
civetweb_add_test(Private "SHA1")
civetweb_add_test(Private "Config Options")

# Public API function tests
civetweb_add_test(PublicFunc "Version")
civetweb_add_test(PublicFunc "Options")
civetweb_add_test(PublicFunc "MIME types")
civetweb_add_test(PublicFunc "strcasecmp")
civetweb_add_test(PublicFunc "URL encoding decoding")
civetweb_add_test(PublicFunc "Cookies and variables")
civetweb_add_test(PublicFunc "MD5")
civetweb_add_test(PublicFunc "Aux functions")

# Public API server tests
civetweb_add_test(PublicServer "Check test environment")
civetweb_add_test(PublicServer "Init library")
civetweb_add_test(PublicServer "Start threads")
civetweb_add_test(PublicServer "Minimal HTTP Server")
civetweb_add_test(PublicServer "Minimal HTTPS Server")
civetweb_add_test(PublicServer "Minimal HTTP Client")
civetweb_add_test(PublicServer "Minimal HTTPS Client")
civetweb_add_test(PublicServer "Start Stop HTTP Server")
civetweb_add_test(PublicServer "Start Stop HTTP Server IPv6")
civetweb_add_test(PublicServer "Start Stop HTTPS Server")
civetweb_add_test(PublicServer "TLS Server Client")
civetweb_add_test(PublicServer "Server Requests")
civetweb_add_test(PublicServer "Store Body")
civetweb_add_test(PublicServer "Handle Form")
civetweb_add_test(PublicServer "HTTP Authentication")
civetweb_add_test(PublicServer "HTTP Keep Alive")
civetweb_add_test(PublicServer "Error handling")
civetweb_add_test(PublicServer "Error logging")
civetweb_add_test(PublicServer "Limit speed")
civetweb_add_test(PublicServer "Large file")
civetweb_add_test(PublicServer "File in memory")

# Timer tests
civetweb_add_test(Timer "Timer Single Shot")
civetweb_add_test(Timer "Timer Periodic")
civetweb_add_test(Timer "Timer Mixed")

# Tests with main.c
civetweb_add_test(EXE "Helper funcs")


# Add the coverage command(s)
if (${CMAKE_BUILD_TYPE} MATCHES "[Cc]overage")
  find_program(GCOV_EXECUTABLE gcov)
  find_program(LCOV_EXECUTABLE lcov)
  find_program(GENHTML_EXECUTABLE genhtml)
  find_program(CTEST_EXECUTABLE ctest)
  if (GCOV_EXECUTABLE AND LCOV_EXECUTABLE AND GENHTML_EXECUTABLE AND CTEST_EXECUTABLE AND HAVE_C_FLAG_COVERAGE)
    add_custom_command(
      OUTPUT ${CMAKE_BINARY_DIR}/lcov/index.html
      COMMAND ${LCOV_EXECUTABLE} -q -z -d .
      COMMAND ${LCOV_EXECUTABLE} -q --no-external -c -b "${CMAKE_SOURCE_DIR}" -d . -o before.lcov -i
      COMMAND ${CTEST_EXECUTABLE} --force-new-ctest-process
      COMMAND ${LCOV_EXECUTABLE} -q --no-external -c -b "${CMAKE_SOURCE_DIR}" -d . -o after.lcov
      COMMAND ${LCOV_EXECUTABLE} -q -a before.lcov -a after.lcov --output-file final.lcov
      COMMAND ${LCOV_EXECUTABLE} -q -r final.lcov "'${CMAKE_SOURCE_DIR}/unittest/*'" -o final.lcov
      COMMAND ${GENHTML_EXECUTABLE} final.lcov -o lcov --demangle-cpp --sort -p "${CMAKE_SOURCE_DIR}" -t benchmark
      DEPENDS main-c-unit-test
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
      COMMENT "Running LCOV"
    )
    add_custom_target(coverage
      DEPENDS ${CMAKE_BINARY_DIR}/lcov/index.html
      COMMENT "LCOV report at lcov/index.html"
    )
    message(STATUS "Coverage command added")
  else()
    if (HAVE_C_FLAG_COVERAGE)
      set(C_FLAG_COVERAGE_MESSAGE supported)
    else()
      set(C_FLAG_COVERAGE_MESSAGE unavailable)
    endif()
    message(WARNING
      "Coverage command not available:\n"
      "  gcov: ${GCOV_EXECUTABLE}\n"
      "  lcov: ${LCOV_EXECUTABLE}\n"
      "  genhtml: ${GENHTML_EXECUTABLE}\n"
      "  ctest: ${CTEST_EXECUTABLE}\n"
      "  --coverage flag: ${C_FLAG_COVERAGE_MESSAGE}")
  endif()
endif()

=== debian/changelog ===
civetweb (1.13+dfsg-5) unstable; urgency=medium

  * Team Upload.
  * Build-Depend on libjs-jquery and use
    minified file provided in this binary
    (Closes: #980674)

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 21 Jan 2021 20:00:38 +0530

civetweb (1.13+dfsg-4) unstable; urgency=medium

  [ Timo Röhling ]
  * build C++ API as well
    Closes: #974775

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 15:47:00 +0100

civetweb (1.13+dfsg-3) unstable; urgency=medium

  * Fix SOVERSION of the shared library to create "libcivetweb.so.1"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 03 Nov 2020 15:42:33 +0100

civetweb (1.13+dfsg-2) unstable; urgency=medium

  * Upgraded "debian/patches/webdav-uploads" for civetweb 1.13

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 27 Oct 2020 13:40:23 +0100

civetweb (1.13+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Add symbols file

 -- Andreas Tille <tille@debian.org>  Tue, 27 Oct 2020 09:06:32 +0100

civetweb (1.12+dfsg-5) unstable; urgency=medium

  * Patch to support uploads in WebDAV

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 16 Oct 2020 13:40:00 +0200

civetweb (1.12+dfsg-4) unstable; urgency=medium

  * Fix my forgetting of tagging Helmut's issue as closed (Closes: #970544)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 19 Sep 2020 11:51:51 +0200

civetweb (1.12+dfsg-3) unstable; urgency=medium

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Don't use arch-dependent paths in *.install files

  [ Sebastien Jodogne ]
  * Add function to improve the performance of Orthanc on keep-alive

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 19 Sep 2020 10:52:31 +0200

civetweb (1.12+dfsg-2) unstable; urgency=medium

  * Source-only upload
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 17 Sep 2020 09:27:48 +0200

civetweb (1.12+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #970358)

 -- Andreas Tille <tille@debian.org>  Tue, 15 Sep 2020 14:20:35 +0200

=== debian/control ===
Source: civetweb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sebastien Jodogne <s.jodogne@gmail.com>
Section: web
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/civetweb
Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
Homepage: https://github.com/civetweb/civetweb/
Rules-Requires-Root: no

Package: civetweb
Architecture: any
Depends: libcivetweb1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.

Package: libcivetweb1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support (lib)
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.
 .
 This package contains the shared library for civetweb.

Package: libcivetweb-dev
Architecture: any
Section: libdevel
Depends: libcivetweb1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support (devel)
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.
 .
 This package contains the header file for developing applications using
 civetweb.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+all future=+lfs

# "CIVETWEB_SOVERSION" must match the suffix of the Debian package
# (i.e. "libcivetweb1" => "1")
CMAKE_EXTRA_FLAGS += \
        -DCMAKE_BUILD_TYPE=None \
        -DCIVETWEB_BUILD_TESTING=OFF \
        -DCIVETWEB_SOVERSION=1 \
	-DCIVETWEB_ENABLE_CXX=ON \
        -DBUILD_SHARED_LIBS=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp -a /usr/share/javascript/jquery/jquery.min.js test/ajax/jquery.js
	dh_auto_test
endif

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/civetweb/civetweb/releases .*/archive/v?@ANY_VERSION@\.tar\.gz

## civetweb 1.15+dfsg

=== debian/changelog ===
civetweb (1.15+dfsg-3) unstable; urgency=medium

  * Provide symbols for amd64 architecture only to reduce burden of
    maintenance

 -- Andreas Tille <tille@debian.org>  Tue, 07 Dec 2021 16:25:40 +0100

civetweb (1.15+dfsg-2) unstable; urgency=medium

  * Add websockets support
    Closes: #989287
  * For whatever reason dh_makeshlibs adds extra symbols including Debian
    revision.  Providing the result from that process as new symbols file
    after stripping revision

 -- Andreas Tille <tille@debian.org>  Tue, 07 Dec 2021 15:45:21 +0100

civetweb (1.15+dfsg-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Remove Debian revision from symbols

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 09:36:08 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/civetweb
 Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
 Homepage: https://github.com/civetweb/civetweb/
@@ -35,6 +35,7 @@
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: embeddable web server with optional CGI, SSL and Lua support (lib)
  CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
  with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
@@ -55,6 +56,7 @@
 Depends: libcivetweb1 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: embeddable web server with optional CGI, SSL and Lua support (devel)
  CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
  with optional CGI, SSL and Lua support. CivetWeb has a MIT license so

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,8 @@
         -DCIVETWEB_BUILD_TESTING=OFF \
         -DCIVETWEB_SOVERSION=1 \
 	-DCIVETWEB_ENABLE_CXX=ON \
-        -DBUILD_SHARED_LIBS=ON
+        -DBUILD_SHARED_LIBS=ON \
+        -DCIVETWEB_ENABLE_WEBSOCKETS=ON
 
 %:
 	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/civetweb/civetweb/releases .*/v?@ANY_VERSION@\.tar\.gz

## civetweb 1.16%2Bdfsg

=== examples/client/Makefile ===
#
# Copyright (c) 2021 CivetWeb Developers
# License http://opensource.org/licenses/mit-license.php MIT License

TOP = ../..

PROG = client
SRC = client.c $(TOP)/src/civetweb.c

CFLAGS = -I$(TOP)/include -DOPENSSL_API_1_1 -DCRYPTO_LIB=\"libcrypto.so.1.1\" -DSSL_LIB=\"libssl.so.1.1\" $(COPT)
LIBS = -lpthread

include $(TOP)/resources/Makefile.in-os

ifeq ($(TARGET_OS),LINUX)
	LIBS += -ldl
endif

all: $(PROG)

$(PROG): $(CIVETWEB_LIB) $(SRC)
	$(CC) -o $@ $(CFLAGS) $(LDFLAGS) $(SRC) $(CIVETWEB_LIB) $(LIBS)

$(CIVETWEB_LIB):
	$(MAKE) -C $(TOP) WITH_IPV6=1 clean lib
	cp $(TOP)/$(CIVETWEB_LIB) .

clean:
	rm -f $(CIVETWEB_LIB) $(PROG)

.PHONY: all clean

=== debian/changelog ===
civetweb (1.16+dfsg-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:44:05 +0200

civetweb (1.16+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Sebastien Jodogne ]
  * Update symbols file (Closes: #1037603)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Remove constraints unnecessary since bullseye (oldstable):
    + Build-Depends: Drop versioned constraint on libjs-jquery (>=
      3.5.1+dfsg+~3.5.5-7).
  * Install pkgconfig files
  * Update symbols

  [ Étienne Mollier ]
  * d/libcivetweb1.symbols.amd64: update symbol table some more.  Changes
    include the marking of a couple of symbols leaked by g++ as optional.
  * d/rules: move pkgconfig files.  Their content is architecture specific, so
    they must relocate to an architecture specific directory.

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Jul 2023 19:30:39 +0200

civetweb (1.15+dfsg-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 01 Nov 2022 20:04:28 +0100

## civetweb 1.16+dfsg

=== unittest/CMakeLists.txt ===
--- 
+++ 
@@ -5,41 +5,27 @@
   set(THIRD_PARTY_LOGGING 1)
 endif()
 
+message(STATUS "CMAKE UNIT TEST LINE 8")
+
 # We use the check unit testing framework for our C unit tests
 include(ExternalProject)
-if(NOT WIN32)
-  # Apply the patch to check to fix CMake building on OS X
-  set(CHECK_PATCH_COMMAND patch
-     ${CIVETWEB_THIRD_PARTY_DIR}/src/check-unit-test-framework/src/check_run.c
-     ${CMAKE_SOURCE_DIR}/cmake/check/check_run.patch
-   )
-else()
-  set(CHECK_PATCH_COMMAND "")
-endif()
-
 IF (DEFINED ENV{CHECK_URL})
 SET (CHECK_URL $ENV{CHECK_URL})
 ELSE()
 SET (CHECK_URL "https://github.com/civetweb/check/archive/master.zip")
 ENDIF()
 
+## Print what version of the CHECK unit test framework we are using
+message(STATUS "Using check unit test framework from ${CHECK_URL}")
 
 ExternalProject_Add(check-unit-test-framework
   DEPENDS civetweb-c-library
 
-## Use an official, released check version:
-#  URL "https://codeload.github.com/libcheck/check/zip/${CIVETWEB_CHECK_VERSION}"
-#  DOWNLOAD_NAME "${CIVETWEB_CHECK_VERSION}.zip"
-#  URL_MD5 ${CIVETWEB_CHECK_MD5_HASH}
-
-## Use a civetweb specific patched version
-
 URL ${CHECK_URL}
 DOWNLOAD_NAME "master.zip"
 
   PREFIX "${CIVETWEB_THIRD_PARTY_DIR}"
   BUILD_IN_SOURCE 1
-  PATCH_COMMAND ${CHECK_PATCH_COMMAND}
   CMAKE_ARGS
     "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
     "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}"
@@ -50,7 +36,8 @@
   LOG_BUILD ${THIRD_PARTY_LOGGING}
   LOG_TEST ${THIRD_PARTY_LOGGING}
   LOG_INSTALL ${THIRD_PARTY_LOGGING})
-
+  
+  
 ExternalProject_Get_Property(check-unit-test-framework INSTALL_DIR)
 set(CHECK_INSTALL_DIR ${INSTALL_DIR})
 unset(INSTALL_DIR)
@@ -168,6 +155,7 @@
 civetweb_add_test(Private "Internal Parsing 4")
 civetweb_add_test(Private "Internal Parsing 5")
 civetweb_add_test(Private "Internal Parsing 6")
+civetweb_add_test(Private "Internal Parsing 7")
 civetweb_add_test(Private "Encode Decode")
 civetweb_add_test(Private "Mask Data")
 civetweb_add_test(Private "Date Parsing")
@@ -180,6 +168,7 @@
 civetweb_add_test(PublicFunc "MIME types")
 civetweb_add_test(PublicFunc "strcasecmp")
 civetweb_add_test(PublicFunc "URL encoding decoding")
+civetweb_add_test(PublicFunc "BASE64 encoding decoding")
 civetweb_add_test(PublicFunc "Cookies and variables")
 civetweb_add_test(PublicFunc "MD5")
 civetweb_add_test(PublicFunc "Aux functions")
@@ -205,7 +194,6 @@
 civetweb_add_test(PublicServer "Error logging")
 civetweb_add_test(PublicServer "Limit speed")
 civetweb_add_test(PublicServer "Large file")
-civetweb_add_test(PublicServer "File in memory")
 
 # Timer tests
 civetweb_add_test(Timer "Timer Single Shot")

=== examples/linux_ws_server_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(linux_ws_server)

set(TARGET_NAME ${PROJECT_NAME})
set(CMAKE_CXX_STANDARD 14)

find_package(PkgConfig REQUIRED)
find_package(civetweb)


include_directories(
    ${civetweb_INCLUDE_DIR}
)

link_directories (
    /usr/local/lib
)

add_executable(${TARGET_NAME} main.cc)

target_link_libraries(${TARGET_NAME}
    libcivetweb-cpp.so
    libcivetweb.so
)

=== debian/changelog ===
civetweb (1.16+dfsg-3) unstable; urgency=medium

  * Team upload.
  * debian/rules: Set cmake minimum version to 3.5 (Closes: #1112780)
  * Cherry-pick proposed patch for CVE-2025-55763

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 27 Sep 2025 01:10:04 +0200

civetweb (1.16+dfsg-2) unstable; urgency=medium

  * Unfuzz patches.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/libcivetweb1.symbols.amd64: mark compiler symbols optional.
    (Closes: #1015368, #1074884)
  * d/rules: forcefully rule LTO builds.
  * d/clean: new: cleanup test/ajax/jquery.js. (Closes: #1043758)
  * d/libcivetweb1.symbols.amd64: specify B-D-P: libcivetweb-dev.

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Jul 2024 23:23:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: civetweb
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
-           Sebastien Jodogne <s.jodogne@gmail.com>
+           Sebastien Jodogne <s.jodogne@gmail.com>,
+           Étienne Mollier <emollier@debian.org>
 Section: web
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
-Standards-Version: 4.6.0
+               libjs-jquery
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/civetweb
 Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
 Homepage: https://github.com/civetweb/civetweb/

=== debian/rules ===
--- 
+++ 
@@ -3,11 +3,16 @@
 # DH_VERBOSE := 1
 export LC_ALL=C.UTF-8
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+all future=+lfs
+export DEB_BUILD_MAINT_OPTIONS = \
+	hardening=+all \
+	reproducible=+all \
+	future=+lfs \
+	optimize=+lto
 
 # "CIVETWEB_SOVERSION" must match the suffix of the Debian package
 # (i.e. "libcivetweb1" => "1")
 CMAKE_EXTRA_FLAGS += \
+        -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
         -DCMAKE_BUILD_TYPE=None \
         -DCIVETWEB_BUILD_TESTING=OFF \
         -DCIVETWEB_SOVERSION=1 \
@@ -26,3 +31,11 @@
 	cp -a /usr/share/javascript/jquery/jquery.min.js test/ajax/jquery.js
 	dh_auto_test
 endif
+
+CIVETWEB_DEV_DIR = $(CURDIR)/debian/libcivetweb-dev
+execute_after_dh_install:
+	# Fix pkg-config-multi-arch-wrong-dir: pkgconfig files contain
+	# architecture specific information, so must be installed in an
+	# architecture specific location.
+	mv -v $(CIVETWEB_DEV_DIR)/usr/share/pkgconfig \
+		$(CIVETWEB_DEV_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/civetweb/civetweb/tags .*/v?@ANY_VERSION@\.tar\.gz
